/*
 * Reporter.java
 *
 * Created on 12 oktober 2006, 14:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
/**
 *
 * @author Arjen
 */


public class Reporter {
    
    private byte[] data = new byte[1024];
    private DatagramSocket socket;
    private DatagramPacket packet;
    private ByteBuffer byteBuffer;
    private int bufferSize;
    private int pixelsInBuffer;
    private final static char start = 's';
    
    
    /**
     * Creates a new instance of Reporter
     */
    public Reporter(InetAddress address) 
    {
        byte [] startBytes = charToByteArray(start);
        try
        {
            DatagramPacket dp = new DatagramPacket(startBytes,0,startBytes.length,address,2002);
            DatagramSocket sender = new DatagramSocket();
            sender.send(dp);
            System.out.println("Sending start packet");
        }catch(Exception e){}
        
        try 
        {
            socket = new DatagramSocket(2001);
            packet = new DatagramPacket(data,data.length);
            byteBuffer = ByteBuffer.wrap(data);
        } 
        catch (Exception e) {e.printStackTrace();}
    }
    
    public void receiveData() 
    {
        
        try{
            socket.receive(packet);
            System.out.println("Timestamp: "+byteBuffer.getInt(0));
            System.out.println("Location horse 1: "+byteBuffer.getInt(4));
            System.out.println("Speed horse 1: "+byteBuffer.getInt(8));
            System.out.println("Location horse 2: "+byteBuffer.getInt(12));
            System.out.println("Speed horse 2: "+byteBuffer.getInt(16));
            System.out.println("Location horse 3: "+byteBuffer.getInt(20));
            System.out.println("Speed horse 3: "+byteBuffer.getInt(24));
            System.out.println("Location horse 4: "+byteBuffer.getInt(28));
            System.out.println("Speed horse 4: "+byteBuffer.getInt(32));
            
        } catch(Exception e){e.printStackTrace();}
    }
    
    static byte [] charToByteArray( char c )
   {
      byte [] twoBytes = { (byte)(c & 0xff), (byte)(c >> 8 & 0xff) };
      return twoBytes;
   }
    
    public static void main(String [] args) throws UnknownHostException
    {
        Reporter rdr;
        if(args.length == 1)
        {
            rdr = new Reporter(InetAddress.getByName(args[0]));
        }
        else
        {
            rdr = new Reporter(InetAddress.getLocalHost());
        }
        while(true){rdr.receiveData();}
    }
}

